'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

exports.default = getSpecsForFile;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _react = require('@storybook/react');

var _addons = require('@storybook/addons');

var _addons2 = _interopRequireDefault(_addons);

var _babelCore = require('babel-core');

var _channelMock = require('./storybook/channel-mock');

var _channelMock2 = _interopRequireDefault(_channelMock);

var _require_context = require('./storybook/require_context');

var _require_context2 = _interopRequireDefault(_require_context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// eslint-disable-next-line import/no-extraneous-dependencies
var runtime = 'storybook';

// We need to transform the storybook/config as we are going to eval it


// eslint-disable-next-line import/no-extraneous-dependencies
function getSpecsForFile(filename) {
  // XXX: I wonder if we need to bother doing this?
  _addons2.default.setChannel((0, _channelMock2.default)());

  // NOTE: storyshots uses storybook's `babel_config` code to generate a complex
  // babel config here. I guess it's what storybook does, but none of what it
  // does seems necessary, IMO.
  var contents = (0, _babelCore.transformFileSync)(filename).code;

  // Get all our stories into the storybook
  (0, _require_context2.default)(contents, {
    filename: filename,
    dirname: _path2.default.dirname(filename)
  });

  return (0, _react.getStorybook)().map(function (_ref) {
    var kind = _ref.kind,
        stories = _ref.stories;
    return stories.map(function (_ref2) {
      var name = _ref2.name;
      return {
        name: name,
        // TODO -- get path separator?
        componentName: kind.split('/').slice(-1)[0],
        runtime: runtime,
        input: (0, _stringify2.default)({
          kind: kind,
          name: name
        })
      };
    });
  }).reduce(function (a, b) {
    return [].concat((0, _toConsumableArray3.default)(a), (0, _toConsumableArray3.default)(b));
  }, []); // flatten
}
//# sourceMappingURL=storybook-specs.js.map