#!/usr/bin/env node
'use strict';

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _tester = require('../tester');

var _tester2 = _interopRequireDefault(_tester);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Ensure we can reasonably compile their config even if they aren't using a .babelrc
// register({
//   presets: [['env', { targets: { node: 'current' } }]],
// });

// Ensure NODE_ENV is set
process.env.NODE_ENV = process.env.NODE_ENV || 'development';

// TODO: do we still need the concept of a config? babel-register?
// import register from 'babel-register';

// import readConfig from './config';


_commander2.default.option('-c, --config [path]', 'read config from file').option('-a, --app-code [code]', 'the code for your app, get from chromaticqa.com').option('-s, --script-name [name]', 'How to start your app. Set to none to not start', 'start').option('-p, --port [port]', 'What port does your app serve?', '3000').option('--runtimes [config]', 'Configuration for runtimes', '').option('--create-tunnel [boolean]', 'tunnel the service over the internet (default true)', true).option('--index-url [url]', 'index to connect to').parse(process.argv);

function parseRuntimes(string) {
  var runtimeConfig = {};
  string.split(',').map(function (s) {
    return s.split(':');
  }).forEach(function (_ref) {
    var _ref2 = (0, _slicedToArray3.default)(_ref, 2),
        runtime = _ref2[0],
        config = _ref2[1];

    runtimeConfig[runtime] = config;
  });
  return runtimeConfig;
}

var commandLineOptions = {
  config: _commander2.default.config,
  appCode: _commander2.default.appCode,
  scriptName: _commander2.default.scriptName,
  port: _commander2.default.port,
  runtimeConfig: parseRuntimes(_commander2.default.runtimes),
  createTunnel: _commander2.default.createTunnel !== 'false',
  indexUrl: _commander2.default.indexUrl
};

// const options = readConfig(commandLineOptions);

(0, _tester2.default)(commandLineOptions).then(function (code) {
  return process.exit(code);
}).catch(function (e) {
  return console.error(e);
});
//# sourceMappingURL=chromatic-test.js.map